// *****************************************
// *                                       *
// * MISC.CC                               *
// *                                       *
// * Muut ylimriset roskat              *
// *                                       *
// * MineBombers level editor              *
// * (C) 1998-1999                         *
// * Yrj Kari-Koskinen, Sampo Lankinen    *
// *                                       *
// *****************************************


// Muuttaa kytettvn tykalun eli hiirikursorin
void set_kalu(const int uusi_kalu, BITMAP **c) {

  tkalu = uusi_kalu;

  show_mouse(NULL);

  set_mouse_sprite(c[uusi_kalu]);

  switch(uusi_kalu) {
    case KALU_BRUSH:
            set_mouse_sprite_focus(0, 15);
            break;

    case KALU_PIPETTI:
            set_mouse_sprite_focus(0, 16);
            break;

    case KALU_FILL:
            set_mouse_sprite_focus(4, 22);
            break;

    case KALU_SQUARE:
    case KALU_SELECT:
            set_mouse_sprite_focus(4, 4);
            break;
  }
  show_mouse(screen);
}



// Kysyy nimen ja kirjoittaa sen ulosteeseen, act on LOAD tai SAVE
void kysy_nimi(char *uloste, const int act) {

  int mrk = 0, i = 0;
  char tmp[13];

  tmp[0] = '\0';
  if(uloste)
    uloste[0] = '\0';
  rectfill(screen, 281, 19, 623, 38, 9);

  switch(act) {
     case SAVE:
          textout(screen, font, "Save as:        .mne", 286, 19, 0);
          break;

     case LOAD:
          textout(screen, font, "Load:         .mne", 286, 19, 0);
          break;

     default:
          return;
          break;
  }

  do {
    mrk = getch();
    if(mrk == 8 && i > 0) {
      i--;
      tmp[i] = '\0';
    }
    if(mrk != 8 && mrk != 13) {
      if(i > 7)
        i = 7;
      tmp[i] = mrk;
      tmp[i + 1] = '\0';
      i++;
    }
    if(act == SAVE) {
      rectfill(screen, 352, 19, 415, 28, 9);
      textout(screen, font, tmp, 352, 19, 0);
    }
    if(act == LOAD) {
      rectfill(screen, 334, 19, 397, 28, 9);
      textout(screen, font, tmp, 334, 19, 0);
    }
  }
  while(mrk != 13 && mrk != 27);

  if(i == 0 || mrk == 27) {
    if(uloste)
      uloste[0] = '\0';
    tmp[0] = '\0';
    return;
  }

  strcat(tmp, ".mne");

  if(!access(tmp, F_OK) && act == SAVE) {
    textout(screen, font, "File already exists. Overwrite? (y/n)", 286, 29, 3);
    if( (getch_until("yn")) != 'y')
      kysy_nimi(tmp, SAVE);
  }
  if(access(tmp, F_OK) && act == LOAD) {
    textout(screen, font, "Error: File doesn't exist!", 286, 29, 3);
    getch();
    kysy_nimi(tmp, LOAD);
  }

  // hoidetaan homma parametrill rather than palautusarvolla
  if(tmp[0] != '\0' && uloste)
    strcpy(uloste, tmp);

  return;
}



// Lukee nppimistlt, kunnes joku 'var':in merkeist saadaan ilman casea
int getch_until(const char *var) {

  int mrk, until = 0, i, len;

  len = strlen(var);

  do {
    mrk = getch();
    for(i = 0; i < len; i++)
      if(mrk == int(var[i]))
        until = 1;
  }
  while(until != 1);

  return tolower(mrk);
}



// Lukee grafiikat ja tekstit 'e':hen
int lue_graffat(_entity *e) {

  int xsize = 250, ysize = 40, tavu1, tavu2, position = 0;
  FILE *handle = fopen("palette.dat", "rb");
  char buffer[10000];             // 220 x 40
  int i, x, y, ex, ey;

  if(handle == NULL) return 1;

// RLE-decoding
  while(position < xsize*ysize) {
    tavu1 = fgetc(handle);
    if(tavu1 > 192) {
      tavu2 = fgetc(handle);
      for(; tavu1 > 192; tavu1--)
         buffer[position++] = tavu2;
    }
    else buffer[position++] = tavu1;
  }

// vlibyte
  tavu1 = fgetc(handle);
  if(tavu1 != 0xFF) return 2;


  tavu1 = fgetc(handle);

// nimet & selitykset # 0 - 99
  for(i = 0; i < MAX_ENTS; i++) {
    ex = i % 25;
    ey = (i - (i % 25)) / 25;
    for(y = 0; y < 10; y++)
      for(x = 0; x < 10; x++)
        e[i].gfx[y*10 + x] = buffer[ (ey*10+y)*250 + ex*10 + x];

// entityn nimi, loppuu vlilyntiin (0x20)
    position = 0;
    while(tavu1 != 0x20 && position < 8) {
      e[i].name[position++] = tavu1;
      tavu1 = fgetc(handle);
    }
    if(position >= 8) return 3;
    e[i].name[position] = '\0';
    position = 0;

// tekstirivi 1, loppuu byteen 0xFF
    tavu1 = fgetc(handle);
    while(tavu1 != 0xFF && position < 43) {
      e[i].text[position++] = tavu1;
      tavu1 = fgetc(handle);
    }
    if(position >= 43) return 4;
    e[i].text[position] = '\0';
    position = 0;

// jos byte 0xFF toiseen kertaan  = > tekstirivi 2, loppuu byteen 0xFF
// muuten ei lis teksti
    tavu1 = fgetc(handle);
    if(tavu1 == 0xFF) {
      tavu1 = fgetc(handle);
      while(tavu1 != 0xFF && position < 43) {
        e[i].text2[position++] = tavu1;
        tavu1 = fgetc(handle);
      }
      tavu1 = fgetc(handle);
    }
    if(position >= 43) return 5;
    e[i].text2[position] = '\0';
  }

// # 100  == black entity
  i = 100;
  for(y = 0; y < 10; y++)
    for(x = 0; x < 10; x++)
      e[i].gfx[y*10 + x] = 0;

  position = 0;
  while(tavu1 != 0x20 && position < 8) {
    e[i].name[position++] = tavu1;
    tavu1 = fgetc(handle);
  }
  if(position >= 8) return 6;
  e[i].name[position] = '\0';
  position = 0;

  tavu1 = fgetc(handle);
  while(tavu1 != 0xFF && position < 43) {
    e[i].text[position] = tavu1;
    position++;
    tavu1 = fgetc(handle);
  }
  if(position >=  43) return 7;
  e[i].text[position] = '\0';

  position = 0;
  tavu1 = fgetc(handle);
  if(tavu1 == 0xFF) {
    tavu1 = fgetc(handle);
    while(tavu1 !=  0xFF && position < 43) {
      e[i].text2[position++] = tavu1;
      tavu1 = fgetc(handle);
    }
    tavu1 = fgetc(handle);
  }
  if(position >= 43) return 8;
  e[i].text2[position] = '\0';


// loppubyte eli kytnnss toiseen kertaan 0xFF
  if(tavu1 != 0xFE) return 9;


  fclose(handle);
  printf("\n");

  return 0;
}



// Lukee mbedit.cfg-tiedoston ja asettaa cfg_struct:n muuttujat
int lue_cfg(_cfg *c) {

  FILE *in = fopen("mbedit.cfg", "r");
  char var_name[20], rivi[100], value_str[4], *stream = 0;
  int value = 0, i = 0, row = 0;

// Asetetaan oletusarvot:
  c->undo_max = 10;
  c->show_logo = 1;
  c->tekstit = 1;
  c->pos_text = 1;
  c->palikka_text = 0;
  c->level_shot = 0;
  c->mouse_in_shot = 0;

  if( !in )
    return 1;


  do {
// Luetaan rivi kerrallaan hyppmll kommenttien ja tyhjien ohi
    do {
      stream = fgets(rivi, 100, in);
      row++;
    } while(stream && (rivi[0] == '#' || strlen(rivi) < 2));

// Luetaan 'rivi':st nimi, jossa ei ole merkkej '=', '\n' ja ' '
    i = 0;
    if(stream || strlen(rivi) > 1)
      i = sscanf(rivi, "%19[^=\n ] = %3[0-9]", var_name, value_str);

    if(i == 2) {
      value = strtoll(value_str, NULL, 10);

// Katsotaan, mihin luetut arvot kirjoitetaan
      if(!strcmp(var_name, "UNDO_MAX"))
        c->undo_max = value;

      else if(!strcmp(var_name, "SHOW_LOGO"))
        c->show_logo = value;

      else if(!strcmp(var_name, "TEXTS"))
        c->tekstit = value;

      else if(!strcmp(var_name, "POS_TEXT"))
        c->pos_text = value;

      else if(!strcmp(var_name, "INFO_TEXT"))
        c->palikka_text = value;

      else if(!strcmp(var_name, "MOUSE_IN_SHOT"))
        c->mouse_in_shot = value;

      else if(!strcmp(var_name, "LEVEL_SHOT"))
        c->level_shot = value;

// Lytyik kyttmttmi nimi?
      else {
        printf("\n%sInvalid variable \'%s\' at row %d in \'mbedit.cfg\'.\n",
               rivi, var_name, row);
        printf("Press any key to continue...\n");
        getch();
      }
    }
// Onko rivit syntaxin mukaisia?
    else {
      printf("\n%sParse error at row %d in \'mbedit.cfg\'.\n", rivi, row);
      printf("Press any key to continue...\n");
      getch();
    }
  } while(stream);

  return 0;
}



// Quittaa
int quit(int &saved, char *levelfn, const unsigned char *level) {

  int mrk = 0;

  rectfill(screen, 281, 6, 623, 38, 9);

  if(saved) {
    textout(screen, font, "Quit: Are you sure? (y/n)", 286, 19, 0);
    mrk = getch_until("yn");
    if(mrk == 'n') {
      mrk = 274;
      rectfill(screen, 281, 6, 623, 38, 9);
    }
    else
      mrk = -274;
  }
  else {
    textout(screen, font, "Quit: Save? (y/n/c)", 286, 19, 0);
    textout(screen, font, "Changes have not been saved yet!", 286, 29, 3);
    mrk = getch_until("ync");
    if(mrk == 'c') {
      mrk = 274;
      rectfill(screen, 281, 6, 623, 38, 9);
    }
    else {
      if(mrk == 'y')
        saved = kirjota_leveli(levelfn, level, saved);
      mrk = -274;
    }
  }

  return mrk;
}



// Palauttaa arvotun arvon tietyille entityille (13, 42, 46, 71, 96 ja 2)
unsigned char unrandomize(const unsigned char entity) {

   unsigned char temp;

// random-jutskat poies
  switch(entity) {
    case 67:
    case 68:
    case 69:
    case 70: temp = 67; break;

    case 71:
    case 72:
    case 73:
    case 74: temp = 71; break;

    case 75:
    case 76:
    case 77:
    case 78: temp = 75; break;

    case 79:
    case 80:
    case 81:
    case 82: temp = 79; break;

    case 83:
    case 84:
    case 85:
    case 86: temp = 83; break;

    case 50:
    case 51:
    case 52: temp = 50; break;

    default: temp = entity;
  }

  return temp;
}



// Sama toisinpin = palauttaa eprandomin arvon :)
unsigned char randomize(const unsigned char entity) {

  unsigned char temp;

// randomit pille.
  switch(entity) {
    case 13:
    case 42:
    case 46:
    case 71:
    case 96: temp = entity + (random() % 4);
             break;

    case  2: temp = entity + (random() % 3);
             break;

    default: temp = entity;
  }

  return temp;
}

/*
void piirra_mine_leveli(const _entity *ents, unsigned char *level) {
  int x,y;
  BITMAP *buffer = create_bitmap(620, 430);
  clear(buffer);

  for(y = 1; y < 44; y++)
    for(x = 1; x < 63; x++) {
      piirra_palikka(buffer, ents[ ttbl[ level[y * 68 + x] ] ].gfx,
                     x - 1, y - 1, 0, 0);
      if(level[y * 68 + x] == 48)
        textout(buffer, font, "0", x * 10, y * 10, 3);
    }

  blit(buffer, screen, 0, 0, 5, 45, 620, 430);
  destroy_bitmap(buffer);

  vsync();
  return;
}

void mine_sweep(int mines, unsigned char *level, const _entity *ents) {

#define MIINA   128
#define RUUMIS  102
#define TUNNEL   48
#define LIPPU   152
#define LIPPU_V 107

  int x = 0, y = 0, x_old = 0, y_old = 0, i = 0;
  int mines_left = mines, mines_old = 0, mouse_b_old = 0;

  char mrk = 0, text_buf[40];

  unsigned char temp_level[LEVEL_SIZE], mine_level[LEVEL_SIZE],
                tmp[LEVEL_SIZE];

  BITMAP *tmp_scr = create_bitmap(640, 480);

  show_mouse(NULL);
  memcpy(temp_level, level, LEVEL_SIZE);
  blit(screen, tmp_scr, 0, 0, 0, 0, 640, 480);

  lue_leveli("ms.mne", level);
  piirra_leveli(ents, level);
  show_mouse(screen);

  tee_tyhja_leveli(mine_level);

  while(i < mines) {
    x = random() % 62 + 1;
    y = random() % 43 + 1;
    if(mine_level[y * 68 + x] == MIINA ? 0 : ++i)
      mine_level[y * 68 + x] = MIINA;
  }

  i = 0;
  for(y = 1; y < 45; y++)
    for(x = 1; x < 64; x++)
      if(mine_level[y * 68 + x] == TUNNEL) {
        if(mine_level[y * 68 + x - 1] == MIINA) i++;
        if(mine_level[y * 68 + x + 1] == MIINA) i++;
        if(mine_level[(y - 1) * 68 + x - 1] == MIINA) i++;
        if(mine_level[(y + 1) * 68 + x + 1] == MIINA) i++;
        if(mine_level[(y - 1) * 68 + x + 1] == MIINA) i++;
        if(mine_level[(y + 1) * 68 + x - 1] == MIINA) i++;
        if(mine_level[(y - 1) * 68 + x] == MIINA) i++;
        if(mine_level[(y + 1) * 68 + x] == MIINA) i++;
        mine_level[y * 68 + x] = 48 + i;
        i = 0;
      }

  rectfill(screen, 6, 6, 623, 38, 9);
  strcpy(text_buf, "Top Secret MBEdit MineSweeper v0.10");
  textout(screen, font, text_buf, 20, 19, 0);

  while(mrk != 27) {
    y = (mouse_y - 36) / 10;
    x = (mouse_x + 4)  / 10;

    if(mouse_y > 39 && (y != y_old || x != x_old)) {
      rectfill(screen, 360, 9, 448, 16, 9);
      sprintf(text_buf, "Pos:  %02d,%02d", x + 1, y + 1);
      textout(screen, font, text_buf, 360, 9, 0);
      y_old = y;
      x_old = x;
    }
    else if(mouse_y < 40 && x_old != -1) {
      rectfill(screen, 360, 9, 448, 16, 9);
      textout(screen, font, "Pos:    ,", 360, 9, 0);
      x_old = -1;
    }
    if(mines_left != mines_old) {
      rectfill(screen, 360, 19, 448, 26, 9);
      sprintf(text_buf, "Mines: %4d", mines_left);
      textout(screen, font, text_buf, 360, 19, 0);
      mines_old = mines_left;
    }

    if(mouse_y > 39 && !hiirinappi(TYHJA) && mouse_b_old == TYHJA) {

      if(hiirinappi(VASEN)) {
        if(mine_level[y * 68 + x] == MIINA) {

          level[y * 68 + x + 1]   = (level[y * 68 + x + 1] == LIPPU ?
                                     LIPPU : TUNNEL);
          level[y * 68 + x - 1]   = (level[y * 68 + x - 1] == LIPPU ?
                                     LIPPU : TUNNEL);
          level[(y - 1) * 68 + x] = (level[(y - 1) * 68 + x] == LIPPU ?
                                     LIPPU : TUNNEL);
          level[(y + 1) * 68 + x] = (level[(y + 1) * 68 + x] == LIPPU ?
                                     LIPPU : TUNNEL);

          for(i = 0; i < LEVEL_SIZE; i++) {
            if(mine_level[i] == MIINA)
              if(level[i] != LIPPU)
                level[i] = MIINA;
            if(level[i] == LIPPU)
              if(mine_level[i] != MIINA)
                level[i] = LIPPU_V;
          }
          level[y * 68 + x] = RUUMIS;

          textout(screen, font, "Game Over!", 310, 29, 3);
          show_mouse(NULL);
          piirra_mine_leveli(ents, level);
          show_mouse(screen);
          getch();
          break;
        }
        else
          level[y * 68 + x] = TUNNEL;
        mouse_b_old = VASEN;
      }

      if(hiirinappi(OIKEA)) {
        if(level[y * 68 + x] == LIPPU) {
          level[y * 68 + x] = tmp[y * 68 + x];
          mines_left++;
        }
        else {
          tmp[y * 68 + x] = level[y * 68 + x];
          level[y * 68 + x] = LIPPU;
          mines_left--;
        }
        mouse_b_old = OIKEA;
      }

      show_mouse(NULL);
      piirra_mine_leveli(ents, level);
      show_mouse(screen);
    }
    mouse_b_old = mouse_b;

    if(kbhit()) {
      mrk = getch();
      if(mrk == 0)
        mrk = -getch();

      switch(mrk) {
        case K_F1:
               show_mouse(NULL);
               piirra_mine_leveli(ents, mine_level);
               show_mouse(screen);
               break;

        case K_F2:
               show_mouse(NULL);
               piirra_mine_leveli(ents, level);
               show_mouse(screen);
               break;
      }
    }

  }

  show_mouse(NULL);
  memcpy(level, temp_level, LEVEL_SIZE);
  blit(tmp_scr, screen, 0, 0, 0, 0, 640, 480);
  destroy_bitmap(tmp_scr);
  show_mouse(screen);

  return;
}
*/
